<template>
  <ob-form
    :form-data="formData"
    :is-read-only="!isNew"
    :dropdown-menu="dropdownMenu"
  >
    <div class="row">
      <div class="col-xs-8">
        <div class="row">
          <div class="col-xs-6">
            <ob-input
              :label="dictionaryRu.modal.code"
              v-model="selectedData.code"
              :disabled="true"
            />
          </div>
          <div class="col-xs-6">
            <ob-input
              :label="dictionaryRu.modal.hazard_code"
              v-model="selectedData.hazard_code"
              :disabled="true"
            />
          </div>
        </div>
        <div class="row">
          <div class="col-xs-12">
            <ob-input
              :label="dictionaryRu.modal.name"
              v-model="selectedData.name"
              :disabled="true"
            />
          </div>
        </div>
      </div>
      <div class="col-xs-4">
        <div
          class="image-uploader"
          :class="{'not-data': imageData.length === 0}"
        >
          <div
            v-if="imageData.length > 0"
            class="image-tmbs"
            :style="'background-image: url(data:image/*;base64,' + imageData + ');'"
            @click="openUpload"
          />
          <div
            v-if="!imageData || imageData.length == 0"
            class="image-default"
            @click="openUpload"
          >
            <i class="icon plus"/>
            <span>
              Добавить
            </span>
            <span>
              изображение
            </span>
          </div>
          <ob-uploader
            class="d-none"
            ref="uploader"
            @change="onUploaded"
          />
        </div>
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ob-textarea
          :label="dictionaryRu.modal.description"
          v-model="selectedData.description"
          :disabled="true"
        />
      </div>
    </div>
  </ob-form>
</template>

<script>
import { uuid }       from 'vue-uuid'
import api            from '@/api'
import dropdownEvents from '@/mixins/dictionaries/dropdown-events'

import ObInput    from 'common-components/src/obComponents/obInput'
import ObTextarea from 'common-components/src/obComponents/obTextarea'
import ObUploader from 'common-components/src/obComponents/obUploader'
import ObForm     from 'common-components/src/obComponents/obForm'

import { dictionaryDefault } from '@/translations/ru/default'
import { dictionary }        from '@/translations/ru/dictionaries__cargo__dangerous_goods_classes'

export default {
  name: 'DangerousGoodsClass',
  components: {
    ObTextarea,
    ObInput,
    ObUploader,
    ObForm
  },
  props: {
    selectedData: {
      type: Object,
      required: true,
      default: () => {}
    },
    imageData: {
      type: String,
      default: ''
    }
  },
  data() {
    return {
      dictionaryRu: Object.assign(dictionary, dictionaryDefault)
    }
  },
  mixins: [ dropdownEvents ],
  computed: {
    formData () {
      return this.selectedData
    },
    isNew () {
      return !this.formData.uuid;
    }
  },
  methods: {
    onUploaded(e) {
      if (e.value && e.value[0]) {
        const file = e.value[0];
        const reader = new FileReader();
        reader.readAsDataURL(file);
        reader.onload = () => {
          const _data = {
            uuid: uuid.v4(),
            file_name: this.selectedData.name,
            content: reader.result.split('base64,')[1],
          };
          api.cargo.createDangerousGoodsClassImage(this.selectedData.uuid, _data).then(() => {
            this.$emit('changed-image', _data.content)
          }).catch((e) => {
            console.error(e);
            this.$notification({
              type: 'system_notification_error',
              message: 'Ошибка сохранения данных'
            })
          })
        };
        reader.onerror = () => {
          this.$notification({
            type: 'system_notification_error',
            message: this.dictionaryRu.loadingError
          })
        }
      } else {
        this.$notification({
          type: 'system_notification_error',
          message: this.dictionaryRu.loadingError
        })
      }
    },
    openUpload() {
      this.$refs.uploader.$el.querySelector('.dx-fileuploader-button').click()
    }
  }
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

.image-uploader {
  position: relative;
  width: 124px;
  height: 124px;
  .icon {
    font-size: 24px;
    margin-bottom: 8px;
    &::before {
      color: $color-grey-span;
    }
  }
  .image-tmbs {
    position: absolute;
    width: 100%;
    height: 100%;
    top: 0;
    left: 0;
    overflow: hidden;
    border-radius: 5px !important;
    background-size: cover;
    background-position: center center;
    cursor: pointer;
  }
  .image-default {
    @include font-mixin(12px, 12px, 400);

    display: flex;
    flex-direction: column;
    justify-content: center;
    align-self: center;
    width: 100%;
    height: 100%;
    border: 1px solid $color-grey-border;
    border-radius: 3px;
    cursor: pointer;
  }
  .dx-fileuploader {
    display: none;
  }
}

.d-none {
  display: none;
}
</style>
